import os, pygame, random, math
import data, functions
pygame.font.init()



tinyFont = pygame.font.Font(data.filepath(os.path.join(".\..\data", "kidsn.ttf")), 8)
normalFont = pygame.font.Font(data.filepath(os.path.join(".\..\data", "kidsn.ttf")), 16) 
hugeFont = pygame.font.Font(data.filepath(os.path.join(".\..\data", "kidsn.ttf")), 26)

  


class Child():
    def __init__(self, num, name, level, init_pos):
        self.num=num        
        self.name=name

        self.image=data.load_image(name.lower()+'.png')

        self.bandagecolor=[0,0,0]
        self.level=level        

        self.pos=self.image.get_rect().inflate(-10,-10).move(init_pos)        
        self.direction=math.radians(random.randrange(360))
        self.speed=0
        self.actionLength=1800
        self.actionDecr=60/random.randrange(1,7)
        self.grab=None
        self.grabbed=0
        self.message=None
        self.isTarget=False
        self.status='none'

        
   
    def draw(self):
        #enhancement of ppl reached by voice
        if self.level.cheat==True:
            if self.level.me!=None:
                if (self.level.me.pos.centerx-self.pos.centerx)**2 + (self.level.me.pos.centery-self.pos.centery)**2 <= self.level.me.volume**2**2:
                    self.angle_text=tinyFont.render(str(math.degrees(functions.calc_dir(self.level.me.getpos(),self.getpos(),self.level.me.direction))), 0, (0,0,0))
                    self.level.screen.blit(self.angle_text, [self.pos.left,self.pos.top-15])                    
                    '''
                    if functions.calc_dir(self.level.me.getpos(),self.getpos(),self.level.me.direction)>self.level.me.direction-math.pi*self.level.me.volume/60 \
                    and functions.calc_dir(self.level.me.getpos(),self.getpos(),self.level.me.direction)<self.level.me.direction+math.pi*self.level.me.volume/60:
                        pygame.draw.circle(self.level.screen,[0,255,0],self.getpos(),25,1)
                    '''
                    clockwise_border=(self.level.me.direction-math.pi/12*(self.level.me.volume-5))%(2*math.pi)
                    counterclockwise_border=(self.level.me.direction+math.pi/12*(self.level.me.volume-5))%(2*math.pi)
                    if counterclockwise_border>clockwise_border:
                        if functions.calc_dir(self.level.me.getpos(),self.getpos(),self.level.me.direction)>=clockwise_border \
                        and functions.calc_dir(self.level.me.getpos(),self.getpos(),self.level.me.direction)<=counterclockwise_border:
                            pygame.draw.circle(self.level.screen,[255,0,255],self.getpos(),20,2)                        
                    else:
                        #counterclockwise_border+=(math.pi*2)
                        if (functions.calc_dir(self.level.me.getpos(),self.getpos(),self.level.me.direction)>=0 and \
                        functions.calc_dir(self.level.me.getpos(),self.getpos(),self.level.me.direction)<=counterclockwise_border) or\
                        (functions.calc_dir(self.level.me.getpos(),self.getpos(),self.level.me.direction)>=clockwise_border and \
                        functions.calc_dir(self.level.me.getpos(),self.getpos(),self.level.me.direction)<=360):
                            pygame.draw.circle(self.level.screen,[255,0,255],self.getpos(),20,2)


        if self.grabbed>0:
            if self.actionDecr==0:
                self.bandagecolor=[255,0,0]
            else:
                self.bandagecolor=[255,165,0]
        else:
            self.bandagecolor=[0,0,0]
        
        if self.level.cheat==True:
            self.msg1=tinyFont.render(str(self.num)+' - '+str(self.name)+' - '+str(self.actionLength), 0, (0,0,0))
            if self.status=='grab':
                #pygame.draw.line(self.level.screen,[0,255,0],self.getpos(),[self.getpos()[0]+math.copysign(10,self.grab.pos.centerx-self.pos.centerx),self.getpos()[1]+math.copysign(10,self.grab.pos.centery-self.pos.centery)],1)        
                self.msg2=tinyFont.render(str(self.status)+' - '+str(self.grab.num)+' - '+str(self.name), 0, (0,0,0))
            else:
                self.msg2=tinyFont.render(str(self.status)+' - '+str(math.degrees(self.direction)), 0, (0,0,0))
            
        

        self.level.screen.blit(self.image, [self.pos.left-5,self.pos.top-5])

        pygame.draw.rect(self.level.screen,self.bandagecolor,[self.pos.centerx-self.pos.width/2,self.pos.centery-self.pos.width/8,self.pos.width,self.pos.height/5],2)

        if self.level.cheat==True:
            self.level.screen.blit(self.msg1, [self.pos.left,self.pos.bottom+5])
            self.level.screen.blit(self.msg2, [self.pos.left,self.pos.bottom+15])
            pygame.draw.rect(self.level.screen,self.bandagecolor,self.pos,1)
        


            

    def getpos(self):
        return self.pos.centerx,self.pos.centery

        
    def checkcollisions(self):
        for ac in self.level.allChildrens:
            #when com hurts someone it grabs the target
            if self.num<>ac.num and self.pos.inflate(2,2).colliderect(ac.pos) and self.status=='move':
                #print str(self.num)+' grabs '+ str(ac.num)
                self.status='coll'
                self.grab=ac
                self.grab.grabbed+=1
                
                #and if target is not grabbing, com is also grabbed by com target
                if self.grab.status not in ['coll','grab','free'] and self.grab.__class__!=Davide:
                    #print str(ac.num)+' grabs '+ str(self.num)
                    self.grab.status='coll'
                    self.grab.grab=self
                    self.grabbed+=1                    

                
        
    def checkborders(self):
        self.pos.centerx=60+(self.pos.centerx-60)%(self.level.screen.get_width()-120)
        self.pos.centery=60+(self.pos.centery-60)%(self.level.screen.get_height()-120)

    def move(self):
        if self.grabbed>0:
           self.speed=0
        
        if self.status=='none':
            self.status=random.choice(['stop','move','move'])
            self.direction=math.radians(random.randrange(360))
            self.actionLength=1800
            self.actionDecr=random.choice([200,100,70,50,40])
            self.actionDecr=60/random.randrange(1,7)

        elif self.status=='stop':
            self.speed=0
            if self.actionLength<=0:
                self.status='none'
            else:
                self.actionLength-=self.actionDecr

        elif self.status=='coll':
            self.speed=0
            #move one step behind to avoid further collision
            self.pos=self.pos.move([math.copysign(1,self.pos.centerx-self.grab.pos.centerx),math.copysign(1,self.pos.centery-self.grab.pos.centery)])
            self.actionLength=1800
            self.status='grab'            
            
        elif self.status=='grab':
            self.speed=0
            if self.actionLength<=0:
                self.status='free'
            else:
                self.actionLength-=self.actionDecr
   
        elif self.status=='free':
            #set direction opposite from collision
            self.direction=functions.calc_dir(self.getpos(),self.grab.getpos(),self.direction)+math.pi
            self.grab.grabbed-=1
            self.grab=None            
            self.status='none'
      
        elif self.status=='move':
            self.speed=1
            if self.actionLength<=0:
                self.status='none'
            else:
                self.pos=self.pos.move(round(self.speed*math.cos(self.direction)),-round(self.speed*math.sin(self.direction)))
                self.actionLength-=self.actionDecr


    
       

    def update(self):
        self.draw()
        self.checkcollisions()
        self.checkborders()
        self.move()


class Davide(Child):
    def __init__(self, num, name, level, init_pos):
        Child.__init__(self, num, name, level, init_pos)
        self.image=data.load_image('davide.png')
        self.image_sad=data.load_image('davide_sad.png')
        self.speed=[0,0]
        self.command_dir=0
        self.dir_text=hugeFont.render('', 0, (0,0,0))
        self.volume=9


    def draw(self):
        if self.level.cheat==True:
            #pygame.draw.arc(self.level.screen,[0,255,0],self.pos.inflate(2*(self.volume)**2-self.pos.width,2*(self.volume)**2-self.pos.height),self.direction-math.pi*self.volume/60,self.direction+math.pi*self.volume/60,2)
            #pygame.draw.line(self.level.screen,[0,255,0],self.getpos(),[self.getpos()[0]+math.cos(self.direction-math.pi*self.volume/60)*self.volume**2,self.getpos()[1]-math.sin(self.direction-math.pi*self.volume/60)*self.volume**2])
            #pygame.draw.line(self.level.screen,[0,255,0],self.getpos(),[self.getpos()[0]+math.cos(self.direction+math.pi*self.volume/60)*self.volume**2,self.getpos()[1]-math.sin(self.direction+math.pi*self.volume/60)*self.volume**2])
            pygame.draw.arc(self.level.screen,[255,0,255],self.pos.inflate(2*(self.volume)**2-self.pos.width,2*(self.volume)**2-self.pos.height),self.direction-math.pi/12*(self.volume-5),self.direction+math.pi/12*(self.volume-5),3)            
            pygame.draw.line(self.level.screen,[255,0,255],self.getpos(),[self.getpos()[0]+math.cos(self.direction+math.pi/12*(self.volume-5))*self.volume**2,self.getpos()[1]-math.sin(self.direction+math.pi/12*(self.volume-5))*self.volume**2],3)
            pygame.draw.line(self.level.screen,[255,0,255],self.getpos(),[self.getpos()[0]+math.cos(self.direction-math.pi/12*(self.volume-5))*self.volume**2,self.getpos()[1]-math.sin(self.direction-math.pi/12*(self.volume-5))*self.volume**2],3)        
            clockwise_border=(self.level.me.direction-math.pi/12*(self.level.me.volume-5))%(2*math.pi)
            counterclockwise_border=(self.level.me.direction+math.pi/12*(self.level.me.volume-5))%(2*math.pi)

            self.angle1_text=tinyFont.render('CCW'+str(math.degrees(counterclockwise_border)%360), 0, (0,0,0))
            self.angle2_text=tinyFont.render('CW'+str(math.degrees(clockwise_border)%360), 0, (0,0,0))
            self.level.screen.blit(self.angle1_text, [self.getpos()[0]+math.cos(self.direction+math.pi/12*(self.volume-5))*self.volume**2,self.getpos()[1]-math.sin(self.direction+math.pi/12*(self.volume-5))*self.volume**2])   
            self.level.screen.blit(self.angle2_text, [self.getpos()[0]+math.cos(self.direction-math.pi/12*(self.volume-5))*self.volume**2,self.getpos()[1]-math.sin(self.direction-math.pi/12*(self.volume-5))*self.volume**2])

        #command direction
        pygame.draw.line(self.level.screen, [255,0,0], self.getpos(),[self.getpos()[0]+math.cos(self.command_dir)*70,self.getpos()[1]-math.sin(self.command_dir)*70], 6)
        #voice direction
        pygame.draw.line(self.level.screen,[0,255,0],self.getpos(),[self.getpos()[0]+math.cos(self.direction)*50,self.getpos()[1]-math.sin(self.direction)*50], 4)        
       
        if self.grabbed>0:
            self.level.screen.blit(self.image_sad,[self.pos.left-5,self.pos.top-5])
        else:
            self.level.screen.blit(self.image,[self.pos.left-5,self.pos.top-5])  
        
        self.level.screen.blit(self.dir_text, [self.getpos()[0]+math.cos(self.command_dir)*(self.volume**2)/2,self.getpos()[1]-math.sin(self.command_dir)*(self.volume**2)/2])
 
        
        if self.level.cheat==True:
            pygame.draw.rect(self.level.screen,self.bandagecolor,self.pos,1)
            self.msg1=tinyFont.render(str(self.speed)+' - '+str(math.degrees(self.direction))+' - '+str(math.degrees(self.command_dir)), 0, (0,0,0))
            self.level.screen.blit(self.msg1, [self.pos.left,self.pos.bottom+5])            

        
        
    def checkcollisions(self):
        for bc in self.level.blindChildrens:
            #when you hurt a free com it grabs you
            if self.pos.inflate(2,2).colliderect(bc.pos):
                if bc.status not in ['coll','grab','free']:
                    #print str(bc.num)+' grabs '+ str(self.num)                         
                    bc.status='coll'
                    bc.grab=self
                    self.grabbed+=1

    
    def say(self,com,mouse_pos=None):
        for bc in self.level.blindChildrens:
            sendcommand=False
            if (self.pos.centerx-bc.pos.centerx)**2 + (self.pos.centery-bc.pos.centery)**2 <= self.volume**2**2:
                clockwise_border=(self.level.me.direction-math.pi/12*(self.level.me.volume-5))%(2*math.pi)
                counterclockwise_border=(self.level.me.direction+math.pi/12*(self.level.me.volume-5))%(2*math.pi)
                if counterclockwise_border>clockwise_border:
                    if functions.calc_dir(self.level.me.getpos(),self.getpos(),self.level.me.direction)>=clockwise_border \
                    and functions.calc_dir(self.level.me.getpos(),self.getpos(),self.level.me.direction)<=counterclockwise_border:
                        sendcommand=True
                else:
                    #counterclockwise_border+=(math.pi*2)
                    if (functions.calc_dir(self.level.me.getpos(),self.getpos(),self.level.me.direction)>=0 and \
                    functions.calc_dir(self.level.me.getpos(),self.getpos(),self.level.me.direction)<=counterclockwise_border) or\
                    (functions.calc_dir(self.level.me.getpos(),self.getpos(),self.level.me.direction)>=clockwise_border and \
                    functions.calc_dir(self.level.me.getpos(),self.getpos(),self.level.me.direction)<=360):
                        sendcommand=True
            if sendcommand==True:
                if com=='GO':
                    bc.direction=functions.calc_dir(self.getpos(),mouse_pos,self.direction)
                    self.dir_text=normalFont.render(str(functions.com2msg(self.command_dir)), 0, (0,0,0))
                    
                    if bc.status in ['none','stop']:
                        bc.actionLength=1800
                        bc.status='move'
                    if bc.status=='grab':
                        bc.actionLength=0
                if com=='HOLD':
                    if bc.status=='grab':
                        #bc.actionLength=3600
                        bc.actionDecr=0
                if com=='FREE':
                    if bc.status=='grab':
                        bc.actionLength=0  
        
    def move(self):
        self.command_dir=functions.calc_dir(self.getpos(),pygame.mouse.get_pos(),self.direction)
        self.command_dir=(math.pi/4)*round(self.command_dir/(math.pi/4))
        if self.grabbed>0:
           self.speed=[0,0]
        self.pos=self.pos.move(self.speed[0],self.speed[1])

